//+------------------------------------------------------------------+
//|                             enumapper_print_enums_and_values.mq5 |
//|                                                Lorentzos Roussos |
//|                              https://www.mql5.com/en/users/lorio |
//+------------------------------------------------------------------+
#property copyright "Lorentzos Roussos"
#property link      "https://www.mql5.com/en/users/lorio"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
class rankenumtext{
public:
string enum_text,enumeration;
long value;
     
 rankenumtext(void){reset();}
~rankenumtext(void){reset();}
void reset(){
     enum_text=NULL;
     enumeration=NULL;
     value=LONG_MIN;
     }
void set(string _enumeration,string _enum_item,long _value){ 
     enum_text=_enum_item;
     enumeration=_enumeration;
     value=_value;
     }
};

struct enumCatcher{
rankenumtext items[];
       enumCatcher(void){reset();}
      ~enumCatcher(void){reset();}
  void reset(){ArrayFree(items);}
   int add_enum(string _enumeration,string _enum_item,long _value){
       int ns=ArraySize(items)+1;
       ArrayResize(items,ns,0);
       items[ns-1].set(_enumeration,_enum_item,_value);
       return(ns-1);
       } 
       template <typename X>
  void catch(X _enum){
       add_enum(typename(X),EnumToString(_enum),(long)_enum);
       }
  void sort(){
       long sorter[][2];
       ArrayResize(sorter,ArraySize(items),0);
       for(int i=0;i<ArraySize(items);i++){
          sorter[i][0]=items[i].value;
          sorter[i][1]=i;
          }
       ArraySort(sorter);
       rankenumtext replica[];
       ArrayResize(replica,ArraySize(items),0);
       for(int i=0;i<ArraySize(items);i++){replica[i]=items[i];}
       for(int i=0;i<ArraySize(items);i++){
          int ix=(int)sorter[i][1];
          items[i]=replica[ix];
          }
       }
  void write(string filename){
       int f=FileOpen(filename,FILE_WRITE|FILE_TXT);
       if(f!=INVALID_HANDLE){
       for(int i=0;i<ArraySize(items);i++){
       FileWriteString(f,"["+IntegerToString(items[i].value)+"] "+items[i].enumeration+" > "+items[i].enum_text+"\n");
       }
       FileClose(f);
       }
       }
};
int OnInit()
  {
//---
  EventSetMillisecondTimer(333); 
//---
   return(INIT_SUCCEEDED);
  }

void OnTimer(){
EventKillTimer();
enumCatcher IndianaJones;
grab(IndianaJones);
IndianaJones.sort();
IndianaJones.write("EnumsAndValues.txt");
Print("DONE");
ExpertRemove();
}
  
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
  
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }  
void grab(enumCatcher &catcher){
catcher.catch(ACCOUNT_BALANCE);
catcher.catch(ACCOUNT_CREDIT);
catcher.catch(ACCOUNT_PROFIT);
catcher.catch(ACCOUNT_EQUITY);
catcher.catch(ACCOUNT_MARGIN);
catcher.catch(ACCOUNT_FREEMARGIN);
catcher.catch(ACCOUNT_MARGIN_LEVEL);
catcher.catch(ACCOUNT_MARGIN_SO_CALL);
catcher.catch(ACCOUNT_MARGIN_SO_SO);
catcher.catch(ACCOUNT_MARGIN_INITIAL);
catcher.catch(ACCOUNT_MARGIN_MAINTENANCE);
catcher.catch(ACCOUNT_ASSETS);
catcher.catch(ACCOUNT_LIABILITIES);
catcher.catch(ACCOUNT_COMMISSION_BLOCKED);
catcher.catch(ACCOUNT_LOGIN);
catcher.catch(ACCOUNT_TRADE_MODE);
catcher.catch(ACCOUNT_TRADE_ALLOWED);
catcher.catch(ACCOUNT_TRADE_EXPERT);
catcher.catch(ACCOUNT_LEVERAGE);
catcher.catch(ACCOUNT_MARGIN_SO_MODE);
catcher.catch(ACCOUNT_LIMIT_ORDERS);
catcher.catch(ACCOUNT_MARGIN_MODE);
catcher.catch(ACCOUNT_CURRENCY_DIGITS);
catcher.catch(ACCOUNT_FIFO_CLOSE);
catcher.catch(ACCOUNT_HEDGE_ALLOWED);
catcher.catch(ACCOUNT_NAME);
catcher.catch(ACCOUNT_COMPANY);
catcher.catch(ACCOUNT_SERVER);
catcher.catch(ACCOUNT_CURRENCY);
catcher.catch(ACCOUNT_MARGIN_MODE_RETAIL_NETTING);
catcher.catch(ACCOUNT_MARGIN_MODE_EXCHANGE);
catcher.catch(ACCOUNT_MARGIN_MODE_RETAIL_HEDGING);
catcher.catch(ACCOUNT_STOPOUT_MODE_PERCENT);
catcher.catch(ACCOUNT_STOPOUT_MODE_MONEY);
catcher.catch(ACCOUNT_TRADE_MODE_DEMO);
catcher.catch(ACCOUNT_TRADE_MODE_CONTEST);
catcher.catch(ACCOUNT_TRADE_MODE_REAL);
catcher.catch(AF_NONE);
catcher.catch(AF_EXP);
catcher.catch(AF_GELU);
catcher.catch(AF_HARD_SIGMOID);
catcher.catch(AF_LINEAR);
catcher.catch(AF_LRELU);
catcher.catch(AF_RELU);
catcher.catch(AF_SELU);
catcher.catch(AF_SIGMOID);
catcher.catch(AF_SOFTMAX);
catcher.catch(AF_SOFTPLUS);
catcher.catch(AF_SOFTSIGN);
catcher.catch(AF_SWISH);
catcher.catch(AF_TANH);
catcher.catch(AF_TRELU);
catcher.catch(AF_ELU);
catcher.catch(AF_PRELU);
catcher.catch(ALIGN_RIGHT);
catcher.catch(ALIGN_LEFT);
catcher.catch(ALIGN_CENTER);
catcher.catch(ANCHOR_LEFT_UPPER);
catcher.catch(ANCHOR_LEFT);
catcher.catch(ANCHOR_LEFT_LOWER);
catcher.catch(ANCHOR_LOWER);
catcher.catch(ANCHOR_RIGHT_LOWER);
catcher.catch(ANCHOR_RIGHT);
catcher.catch(ANCHOR_RIGHT_UPPER);
catcher.catch(ANCHOR_UPPER);
catcher.catch(ANCHOR_CENTER);
catcher.catch(VOLUME_TICK);
catcher.catch(VOLUME_REAL);
catcher.catch(ANCHOR_TOP);
catcher.catch(ANCHOR_BOTTOM);
catcher.catch(CORNER_LEFT_UPPER);
catcher.catch(CORNER_LEFT_LOWER);
catcher.catch(CORNER_RIGHT_LOWER);
catcher.catch(CORNER_RIGHT_UPPER);
catcher.catch(BOOK_TYPE_SELL);
catcher.catch(BOOK_TYPE_BUY);
catcher.catch(BOOK_TYPE_SELL_MARKET);
catcher.catch(BOOK_TYPE_BUY_MARKET);
catcher.catch(BORDER_FLAT);
catcher.catch(BORDER_RAISED);
catcher.catch(BORDER_SUNKEN);
catcher.catch(CALENDAR_FREQUENCY_NONE);
catcher.catch(CALENDAR_FREQUENCY_WEEK);
catcher.catch(CALENDAR_FREQUENCY_MONTH);
catcher.catch(CALENDAR_FREQUENCY_QUARTER);
catcher.catch(CALENDAR_FREQUENCY_YEAR);
catcher.catch(CALENDAR_FREQUENCY_DAY);
catcher.catch(CALENDAR_IMPACT_NA);
catcher.catch(CALENDAR_IMPACT_POSITIVE);
catcher.catch(CALENDAR_IMPACT_NEGATIVE);
catcher.catch(CALENDAR_IMPORTANCE_NONE);
catcher.catch(CALENDAR_IMPORTANCE_LOW);
catcher.catch(CALENDAR_IMPORTANCE_MODERATE);
catcher.catch(CALENDAR_IMPORTANCE_HIGH);
catcher.catch(CALENDAR_MULTIPLIER_NONE);
catcher.catch(CALENDAR_MULTIPLIER_THOUSANDS);
catcher.catch(CALENDAR_MULTIPLIER_MILLIONS);
catcher.catch(CALENDAR_MULTIPLIER_BILLIONS);
catcher.catch(CALENDAR_MULTIPLIER_TRILLIONS);
catcher.catch(CALENDAR_SECTOR_NONE);
catcher.catch(CALENDAR_SECTOR_MARKET);
catcher.catch(CALENDAR_SECTOR_GDP);
catcher.catch(CALENDAR_SECTOR_JOBS);
catcher.catch(CALENDAR_SECTOR_PRICES);
catcher.catch(CALENDAR_SECTOR_MONEY);
catcher.catch(CALENDAR_SECTOR_TRADE);
catcher.catch(CALENDAR_SECTOR_GOVERNMENT);
catcher.catch(CALENDAR_SECTOR_BUSINESS);
catcher.catch(CALENDAR_SECTOR_CONSUMER);
catcher.catch(CALENDAR_SECTOR_HOUSING);
catcher.catch(CALENDAR_SECTOR_TAXES);
catcher.catch(CALENDAR_SECTOR_HOLIDAYS);
catcher.catch(CALENDAR_TIMEMODE_DATETIME);
catcher.catch(CALENDAR_TIMEMODE_DATE);
catcher.catch(CALENDAR_TIMEMODE_NOTIME);
catcher.catch(CALENDAR_TIMEMODE_TENTATIVE);
catcher.catch(CALENDAR_TYPE_EVENT);
catcher.catch(CALENDAR_TYPE_INDICATOR);
catcher.catch(CALENDAR_TYPE_HOLIDAY);
catcher.catch(CALENDAR_UNIT_NONE);
catcher.catch(CALENDAR_UNIT_PERCENT);
catcher.catch(CALENDAR_UNIT_CURRENCY);
catcher.catch(CALENDAR_UNIT_HOUR);
catcher.catch(CALENDAR_UNIT_JOB);
catcher.catch(CALENDAR_UNIT_RIG);
catcher.catch(CALENDAR_UNIT_USD);
catcher.catch(CALENDAR_UNIT_PEOPLE);
catcher.catch(CALENDAR_UNIT_MORTGAGE);
catcher.catch(CALENDAR_UNIT_VOTE);
catcher.catch(CALENDAR_UNIT_BARREL);
catcher.catch(CALENDAR_UNIT_CUBICFEET);
catcher.catch(CALENDAR_UNIT_POSITION);
catcher.catch(CALENDAR_UNIT_BUILDING);
catcher.catch(CHARTEVENT_KEYDOWN);
catcher.catch(CHARTEVENT_OBJECT_CLICK);
catcher.catch(CHARTEVENT_OBJECT_DRAG);
catcher.catch(CHARTEVENT_OBJECT_ENDEDIT);
catcher.catch(CHARTEVENT_CLICK);
catcher.catch(CHARTEVENT_OBJECT_DELETE);
catcher.catch(CHARTEVENT_OBJECT_CREATE);
catcher.catch(CHARTEVENT_OBJECT_CHANGE);
catcher.catch(CHARTEVENT_CHART_CHANGE);
catcher.catch(CHARTEVENT_MOUSE_MOVE);
catcher.catch(CHARTEVENT_MOUSE_WHEEL);
catcher.catch(CHARTEVENT_CUSTOM);
catcher.catch(CHARTEVENT_CUSTOM_LAST);
catcher.catch(CHART_BARS);
catcher.catch(CHART_CANDLES);
catcher.catch(CHART_LINE);
catcher.catch(CHART_BEGIN);
catcher.catch(CHART_CURRENT_POS);
catcher.catch(CHART_END);
catcher.catch(CHART_SHIFT_SIZE);
catcher.catch(CHART_FIXED_MAX);
catcher.catch(CHART_FIXED_MIN);
catcher.catch(CHART_POINTS_PER_BAR);
catcher.catch(CHART_FIXED_POSITION);
catcher.catch(CHART_PRICE_MIN);
catcher.catch(CHART_PRICE_MAX);
catcher.catch(CHART_MODE);
catcher.catch(CHART_FOREGROUND);
catcher.catch(CHART_SHIFT);
catcher.catch(CHART_AUTOSCROLL);
catcher.catch(CHART_SCALE);
catcher.catch(CHART_SCALEFIX);
catcher.catch(CHART_SCALEFIX_11);
catcher.catch(CHART_SCALE_PT_PER_BAR);
catcher.catch(CHART_SHOW_OHLC);
catcher.catch(CHART_SHOW_BID_LINE);
catcher.catch(CHART_SHOW_ASK_LINE);
catcher.catch(CHART_SHOW_LAST_LINE);
catcher.catch(CHART_SHOW_PERIOD_SEP);
catcher.catch(CHART_SHOW_GRID);
catcher.catch(CHART_SHOW_VOLUMES);
catcher.catch(CHART_SHOW_OBJECT_DESCR);
catcher.catch(CHART_COLOR_BACKGROUND);
catcher.catch(CHART_COLOR_FOREGROUND);
catcher.catch(CHART_COLOR_GRID);
catcher.catch(CHART_COLOR_VOLUME);
catcher.catch(CHART_COLOR_CHART_UP);
catcher.catch(CHART_COLOR_CHART_DOWN);
catcher.catch(CHART_COLOR_CHART_LINE);
catcher.catch(CHART_COLOR_CANDLE_BULL);
catcher.catch(CHART_COLOR_CANDLE_BEAR);
catcher.catch(CHART_COLOR_BID);
catcher.catch(CHART_COLOR_ASK);
catcher.catch(CHART_COLOR_LAST);
catcher.catch(CHART_COLOR_STOP_LEVEL);
catcher.catch(CHART_SHOW_TRADE_LEVELS);
catcher.catch(CHART_BRING_TO_TOP);
catcher.catch(CHART_SHOW_DATE_SCALE);
catcher.catch(CHART_SHOW_PRICE_SCALE);
catcher.catch(CHART_EVENT_OBJECT_CREATE);
catcher.catch(CHART_EVENT_OBJECT_DELETE);
catcher.catch(CHART_EVENT_MOUSE_MOVE);
catcher.catch(CHART_MOUSE_SCROLL);
catcher.catch(CHART_DRAG_TRADE_LEVELS);
catcher.catch(CHART_SHOW_ONE_CLICK);
catcher.catch(CHART_QUICK_NAVIGATION);
catcher.catch(CHART_SHOW);
catcher.catch(CHART_KEYBOARD_CONTROL);
catcher.catch(CHART_EVENT_MOUSE_WHEEL);
catcher.catch(CHART_CROSSHAIR_TOOL);
catcher.catch(CHART_CONTEXT_MENU);
catcher.catch(CHART_IS_DOCKED);
catcher.catch(CHART_FLOAT_LEFT);
catcher.catch(CHART_FLOAT_TOP);
catcher.catch(CHART_FLOAT_RIGHT);
catcher.catch(CHART_FLOAT_BOTTOM);
catcher.catch(CHART_VISIBLE_BARS);
catcher.catch(CHART_WINDOWS_TOTAL);
catcher.catch(CHART_WINDOW_IS_VISIBLE);
catcher.catch(CHART_WINDOW_HANDLE);
catcher.catch(CHART_FIRST_VISIBLE_BAR);
catcher.catch(CHART_WIDTH_IN_BARS);
catcher.catch(CHART_WIDTH_IN_PIXELS);
catcher.catch(CHART_HEIGHT_IN_PIXELS);
catcher.catch(CHART_WINDOW_YDISTANCE);
catcher.catch(CHART_IS_OBJECT);
catcher.catch(CHART_IS_OFFLINE);
catcher.catch(CHART_IS_MAXIMIZED);
catcher.catch(CHART_IS_MINIMIZED);
catcher.catch(CHART_SHOW_TICKER);
catcher.catch(CHART_COMMENT);
catcher.catch(CHART_EXPERT_NAME);
catcher.catch(CHART_SCRIPT_NAME);
catcher.catch(CHART_VOLUME_HIDE);
catcher.catch(CHART_VOLUME_TICK);
catcher.catch(CHART_VOLUME_REAL);
catcher.catch(CL_DEVICE_DEFAULT);
catcher.catch(CL_DEVICE_CPU);
catcher.catch(CL_DEVICE_GPU);
catcher.catch(CL_DEVICE_ACCELERATOR);
catcher.catch(CL_DEVICE_CUSTOM);
catcher.catch(COLOR_FORMAT_XRGB_NOALPHA);
catcher.catch(COLOR_FORMAT_ARGB_RAW);
catcher.catch(COLOR_FORMAT_ARGB_NORMALIZE);
catcher.catch(COPY_RATES_OPEN);
catcher.catch(COPY_RATES_HIGH);
catcher.catch(COPY_RATES_LOW);
catcher.catch(COPY_RATES_CLOSE);
catcher.catch(COPY_RATES_OHLC);
catcher.catch(COPY_RATES_TIME);
catcher.catch(COPY_RATES_OHLCT);
catcher.catch(COPY_RATES_VOLUME_TICK);
catcher.catch(COPY_RATES_VOLUME_REAL);
catcher.catch(COPY_RATES_SPREAD);
catcher.catch(COPY_TICKS_INFO);
catcher.catch(COPY_TICKS_TRADE);
catcher.catch(COPY_TICKS_ALL);
catcher.catch(COPY_TICKS_TIME_MS);
catcher.catch(COPY_TICKS_BID);
catcher.catch(COPY_TICKS_ASK);
catcher.catch(COPY_TICKS_LAST);
catcher.catch(COPY_TICKS_VOLUME);
catcher.catch(COPY_TICKS_FLAGS);
catcher.catch(CRYPT_BASE64);
catcher.catch(CRYPT_AES128);
catcher.catch(CRYPT_AES256);
catcher.catch(CRYPT_DES);
catcher.catch(CRYPT_HASH_SHA1);
catcher.catch(CRYPT_HASH_SHA256);
catcher.catch(CRYPT_HASH_MD5);
catcher.catch(CRYPT_ARCH_ZIP);
catcher.catch(INDICATOR_MINIMUM);
catcher.catch(INDICATOR_MAXIMUM);
catcher.catch(INDICATOR_LEVELVALUE);
catcher.catch(INDICATOR_DIGITS);
catcher.catch(INDICATOR_LEVELS);
catcher.catch(INDICATOR_LEVELCOLOR);
catcher.catch(INDICATOR_LEVELSTYLE);
catcher.catch(INDICATOR_LEVELWIDTH);
catcher.catch(INDICATOR_HEIGHT);
catcher.catch(INDICATOR_FIXED_MINIMUM);
catcher.catch(INDICATOR_FIXED_MAXIMUM);
catcher.catch(INDICATOR_SHORTNAME);
catcher.catch(INDICATOR_LEVELTEXT);
catcher.catch(DATABASE_EXPORT_HEADER);
catcher.catch(DATABASE_EXPORT_INDEX);
catcher.catch(DATABASE_EXPORT_NO_BOM);
catcher.catch(DATABASE_EXPORT_CRLF);
catcher.catch(DATABASE_EXPORT_APPEND);
catcher.catch(DATABASE_EXPORT_QUOTED_STRINGS);
catcher.catch(DATABASE_EXPORT_COMMON_FOLDER);
catcher.catch(DATABASE_FIELD_TYPE_INVALID);
catcher.catch(DATABASE_FIELD_TYPE_INTEGER);
catcher.catch(DATABASE_FIELD_TYPE_FLOAT);
catcher.catch(DATABASE_FIELD_TYPE_TEXT);
catcher.catch(DATABASE_FIELD_TYPE_BLOB);
catcher.catch(DATABASE_FIELD_TYPE_NULL);
catcher.catch(DATABASE_IMPORT_HEADER);
catcher.catch(DATABASE_IMPORT_CRLF);
catcher.catch(DATABASE_IMPORT_APPEND);
catcher.catch(DATABASE_IMPORT_QUOTED_STRINGS);
catcher.catch(DATABASE_IMPORT_COMMON_FOLDER);
catcher.catch(DATABASE_OPEN_READONLY);
catcher.catch(DATABASE_OPEN_READWRITE);
catcher.catch(DATABASE_OPEN_CREATE);
catcher.catch(DATABASE_OPEN_MEMORY);
catcher.catch(DATABASE_OPEN_COMMON);
catcher.catch(DATABASE_PRINT_NO_HEADER);
catcher.catch(DATABASE_PRINT_NO_INDEX);
catcher.catch(DATABASE_PRINT_NO_FRAME);
catcher.catch(DATABASE_PRINT_STRINGS_RIGHT);
catcher.catch(TYPE_BOOL);
catcher.catch(TYPE_CHAR);
catcher.catch(TYPE_UCHAR);
catcher.catch(TYPE_SHORT);
catcher.catch(TYPE_USHORT);
catcher.catch(TYPE_COLOR);
catcher.catch(TYPE_INT);
catcher.catch(TYPE_UINT);
catcher.catch(TYPE_DATETIME);
catcher.catch(TYPE_LONG);
catcher.catch(TYPE_ULONG);
catcher.catch(TYPE_FLOAT);
catcher.catch(TYPE_DOUBLE);
catcher.catch(TYPE_STRING);
catcher.catch(TYPE_VECTOR);
catcher.catch(TYPE_MATRIX);
catcher.catch(TYPE_VECTORF);
catcher.catch(TYPE_MATRIXF);
catcher.catch(TYPE_VECTORC);
catcher.catch(TYPE_MATRIXC);
catcher.catch(SUNDAY);
catcher.catch(MONDAY);
catcher.catch(TUESDAY);
catcher.catch(WEDNESDAY);
catcher.catch(THURSDAY);
catcher.catch(FRIDAY);
catcher.catch(SATURDAY);
catcher.catch(DEAL_ENTRY_IN);
catcher.catch(DEAL_ENTRY_OUT);
catcher.catch(DEAL_ENTRY_INOUT);
catcher.catch(DEAL_ENTRY_OUT_BY);
catcher.catch(DEAL_ENTRY_STATE);
catcher.catch(DEAL_VOLUME);
catcher.catch(DEAL_PRICE);
catcher.catch(DEAL_COMMISSION);
catcher.catch(DEAL_SWAP);
catcher.catch(DEAL_PROFIT);
catcher.catch(DEAL_FEE);
catcher.catch(DEAL_SL);
catcher.catch(DEAL_TP);
catcher.catch(DEAL_ORDER);
catcher.catch(DEAL_TIME);
catcher.catch(DEAL_TYPE);
catcher.catch(DEAL_ENTRY);
catcher.catch(DEAL_MAGIC);
catcher.catch(DEAL_POSITION_ID);
catcher.catch(DEAL_TIME_MSC);
catcher.catch(DEAL_TICKET);
catcher.catch(DEAL_REASON);
catcher.catch(DEAL_SYMBOL);
catcher.catch(DEAL_COMMENT);
catcher.catch(DEAL_EXTERNAL_ID);
catcher.catch(DEAL_REASON_CLIENT);
catcher.catch(DEAL_REASON_MOBILE);
catcher.catch(DEAL_REASON_WEB);
catcher.catch(DEAL_REASON_EXPERT);
catcher.catch(DEAL_REASON_SL);
catcher.catch(DEAL_REASON_TP);
catcher.catch(DEAL_REASON_SO);
catcher.catch(DEAL_REASON_ROLLOVER);
catcher.catch(DEAL_REASON_VMARGIN);
catcher.catch(DEAL_REASON_SPLIT);
catcher.catch(DEAL_TYPE_BUY);
catcher.catch(DEAL_TYPE_SELL);
catcher.catch(DEAL_TYPE_BALANCE);
catcher.catch(DEAL_TYPE_CREDIT);
catcher.catch(DEAL_TYPE_CHARGE);
catcher.catch(DEAL_TYPE_CORRECTION);
catcher.catch(DEAL_TYPE_BONUS);
catcher.catch(DEAL_TYPE_COMMISSION);
catcher.catch(DEAL_TYPE_COMMISSION_DAILY);
catcher.catch(DEAL_TYPE_COMMISSION_MONTHLY);
catcher.catch(DEAL_TYPE_COMMISSION_AGENT_DAILY);
catcher.catch(DEAL_TYPE_COMMISSION_AGENT_MONTHLY);
catcher.catch(DEAL_TYPE_INTEREST);
catcher.catch(DEAL_TYPE_BUY_CANCELED);
catcher.catch(DEAL_TYPE_SELL_CANCELED);
catcher.catch(DEAL_DIVIDEND);
catcher.catch(DEAL_DIVIDEND_FRANKED);
catcher.catch(DEAL_TAX);
catcher.catch(DRAW_NONE);
catcher.catch(DRAW_LINE);
catcher.catch(DRAW_HISTOGRAM);
catcher.catch(DRAW_ARROW);
catcher.catch(DRAW_SECTION);
catcher.catch(DRAW_HISTOGRAM2);
catcher.catch(DRAW_ZIGZAG);
catcher.catch(DRAW_FILLING);
catcher.catch(DRAW_BARS);
catcher.catch(DRAW_CANDLES);
catcher.catch(DRAW_COLOR_LINE);
catcher.catch(DRAW_COLOR_HISTOGRAM);
catcher.catch(DRAW_COLOR_ARROW);
catcher.catch(DRAW_COLOR_SECTION);
catcher.catch(DRAW_COLOR_HISTOGRAM2);
catcher.catch(DRAW_COLOR_ZIGZAG);
catcher.catch(DRAW_COLOR_BARS);
catcher.catch(DRAW_COLOR_CANDLES);
catcher.catch(DX_BUFFER_VERTEX);
catcher.catch(DX_BUFFER_INDEX);
catcher.catch(DX_FORMAT_FORCE_UINT);
catcher.catch(DX_FORMAT_UNKNOWN);
catcher.catch(DX_FORMAT_R32G32B32A32_TYPELESS);
catcher.catch(DX_FORMAT_R32G32B32A32_FLOAT);
catcher.catch(DX_FORMAT_R32G32B32A32_UINT);
catcher.catch(DX_FORMAT_R32G32B32A32_SINT);
catcher.catch(DX_FORMAT_R32G32B32_TYPELESS);
catcher.catch(DX_FORMAT_R32G32B32_FLOAT);
catcher.catch(DX_FORMAT_R32G32B32_UINT);
catcher.catch(DX_FORMAT_R32G32B32_SINT);
catcher.catch(DX_FORMAT_R16G16B16A16_TYPELESS);
catcher.catch(DX_FORMAT_R16G16B16A16_FLOAT);
catcher.catch(DX_FORMAT_R16G16B16A16_UNORM);
catcher.catch(DX_FORMAT_R16G16B16A16_UINT);
catcher.catch(DX_FORMAT_R16G16B16A16_SNORM);
catcher.catch(DX_FORMAT_R16G16B16A16_SINT);
catcher.catch(DX_FORMAT_R32G32_TYPELESS);
catcher.catch(DX_FORMAT_R32G32_FLOAT);
catcher.catch(DX_FORMAT_R32G32_UINT);
catcher.catch(DX_FORMAT_R32G32_SINT);
catcher.catch(DX_FORMAT_R32G8X24_TYPELESS);
catcher.catch(DX_FORMAT_D32_FLOAT_S8X24_UINT);
catcher.catch(DX_FORMAT_R32_FLOAT_X8X24_TYPELESS);
catcher.catch(DX_FORMAT_X32_TYPELESS_G8X24_UINT);
catcher.catch(DX_FORMAT_R10G10B10A2_TYPELESS);
catcher.catch(DX_FORMAT_R10G10B10A2_UNORM);
catcher.catch(DX_FORMAT_R10G10B10A2_UINT);
catcher.catch(DX_FORMAT_R11G11B10_FLOAT);
catcher.catch(DX_FORMAT_R8G8B8A8_TYPELESS);
catcher.catch(DX_FORMAT_R8G8B8A8_UNORM);
catcher.catch(DX_FORMAT_R8G8B8A8_UNORM_SRGB);
catcher.catch(DX_FORMAT_R8G8B8A8_UINT);
catcher.catch(DX_FORMAT_R8G8B8A8_SNORM);
catcher.catch(DX_FORMAT_R8G8B8A8_SINT);
catcher.catch(DX_FORMAT_R16G16_TYPELESS);
catcher.catch(DX_FORMAT_R16G16_FLOAT);
catcher.catch(DX_FORMAT_R16G16_UNORM);
catcher.catch(DX_FORMAT_R16G16_UINT);
catcher.catch(DX_FORMAT_R16G16_SNORM);
catcher.catch(DX_FORMAT_R16G16_SINT);
catcher.catch(DX_FORMAT_R32_TYPELESS);
catcher.catch(DX_FORMAT_D32_FLOAT);
catcher.catch(DX_FORMAT_R32_FLOAT);
catcher.catch(DX_FORMAT_R32_UINT);
catcher.catch(DX_FORMAT_R32_SINT);
catcher.catch(DX_FORMAT_R24G8_TYPELESS);
catcher.catch(DX_FORMAT_D24_UNORM_S8_UINT);
catcher.catch(DX_FORMAT_R24_UNORM_X8_TYPELESS);
catcher.catch(DX_FORMAT_X24_TYPELESS_G8_UINT);
catcher.catch(DX_FORMAT_R8G8_TYPELESS);
catcher.catch(DX_FORMAT_R8G8_UNORM);
catcher.catch(DX_FORMAT_R8G8_UINT);
catcher.catch(DX_FORMAT_R8G8_SNORM);
catcher.catch(DX_FORMAT_R8G8_SINT);
catcher.catch(DX_FORMAT_R16_TYPELESS);
catcher.catch(DX_FORMAT_R16_FLOAT);
catcher.catch(DX_FORMAT_D16_UNORM);
catcher.catch(DX_FORMAT_R16_UNORM);
catcher.catch(DX_FORMAT_R16_UINT);
catcher.catch(DX_FORMAT_R16_SNORM);
catcher.catch(DX_FORMAT_R16_SINT);
catcher.catch(DX_FORMAT_R8_TYPELESS);
catcher.catch(DX_FORMAT_R8_UNORM);
catcher.catch(DX_FORMAT_R8_UINT);
catcher.catch(DX_FORMAT_R8_SNORM);
catcher.catch(DX_FORMAT_R8_SINT);
catcher.catch(DX_FORMAT_A8_UNORM);
catcher.catch(DX_FORMAT_R1_UNORM);
catcher.catch(DX_FORMAT_R9G9B9E5_SHAREDEXP);
catcher.catch(DX_FORMAT_R8G8_B8G8_UNORM);
catcher.catch(DX_FORMAT_G8R8_G8B8_UNORM);
catcher.catch(DX_FORMAT_BC1_TYPELESS);
catcher.catch(DX_FORMAT_BC1_UNORM);
catcher.catch(DX_FORMAT_BC1_UNORM_SRGB);
catcher.catch(DX_FORMAT_BC2_TYPELESS);
catcher.catch(DX_FORMAT_BC2_UNORM);
catcher.catch(DX_FORMAT_BC2_UNORM_SRGB);
catcher.catch(DX_FORMAT_BC3_TYPELESS);
catcher.catch(DX_FORMAT_BC3_UNORM);
catcher.catch(DX_FORMAT_BC3_UNORM_SRGB);
catcher.catch(DX_FORMAT_BC4_TYPELESS);
catcher.catch(DX_FORMAT_BC4_UNORM);
catcher.catch(DX_FORMAT_BC4_SNORM);
catcher.catch(DX_FORMAT_BC5_TYPELESS);
catcher.catch(DX_FORMAT_BC5_UNORM);
catcher.catch(DX_FORMAT_BC5_SNORM);
catcher.catch(DX_FORMAT_B5G6R5_UNORM);
catcher.catch(DX_FORMAT_B5G5R5A1_UNORM);
catcher.catch(DX_FORMAT_B8G8R8A8_UNORM);
catcher.catch(DX_FORMAT_B8G8R8X8_UNORM);
catcher.catch(DX_FORMAT_R10G10B10_XR_BIAS_A2_UNORM);
catcher.catch(DX_FORMAT_B8G8R8A8_TYPELESS);
catcher.catch(DX_FORMAT_B8G8R8A8_UNORM_SRGB);
catcher.catch(DX_FORMAT_B8G8R8X8_TYPELESS);
catcher.catch(DX_FORMAT_B8G8R8X8_UNORM_SRGB);
catcher.catch(DX_FORMAT_BC6H_TYPELESS);
catcher.catch(DX_FORMAT_BC6H_UF16);
catcher.catch(DX_FORMAT_BC6H_SF16);
catcher.catch(DX_FORMAT_BC7_TYPELESS);
catcher.catch(DX_FORMAT_BC7_UNORM);
catcher.catch(DX_FORMAT_BC7_UNORM_SRGB);
catcher.catch(DX_FORMAT_AYUV);
catcher.catch(DX_FORMAT_Y410);
catcher.catch(DX_FORMAT_Y416);
catcher.catch(DX_FORMAT_NV12);
catcher.catch(DX_FORMAT_P010);
catcher.catch(DX_FORMAT_P016);
catcher.catch(DX_FORMAT_420_OPAQUE);
catcher.catch(DX_FORMAT_YUY2);
catcher.catch(DX_FORMAT_Y210);
catcher.catch(DX_FORMAT_Y216);
catcher.catch(DX_FORMAT_NV11);
catcher.catch(DX_FORMAT_AI44);
catcher.catch(DX_FORMAT_IA44);
catcher.catch(DX_FORMAT_P8);
catcher.catch(DX_FORMAT_A8P8);
catcher.catch(DX_FORMAT_B4G4R4A4_UNORM);
catcher.catch(DX_FORMAT_P208);
catcher.catch(DX_FORMAT_V208);
catcher.catch(DX_FORMAT_V408);
catcher.catch(DX_HANDLE_INVALID);
catcher.catch(DX_HANDLE_CONTEXT);
catcher.catch(DX_HANDLE_SHADER);
catcher.catch(DX_HANDLE_BUFFER);
catcher.catch(DX_HANDLE_INPUT);
catcher.catch(DX_HANDLE_TEXTURE);
catcher.catch(DX_PRIMITIVE_TOPOLOGY_POINTLIST);
catcher.catch(DX_PRIMITIVE_TOPOLOGY_LINELIST);
catcher.catch(DX_PRIMITIVE_TOPOLOGY_LINESTRIP);
catcher.catch(DX_PRIMITIVE_TOPOLOGY_TRIANGLELIST);
catcher.catch(DX_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP);
catcher.catch(DX_PRIMITIVE_TOPOLOGY_LINELIST_ADJ);
catcher.catch(DX_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ);
catcher.catch(DX_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ);
catcher.catch(DX_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ);
catcher.catch(DX_SHADER_VERTEX);
catcher.catch(DX_SHADER_GEOMETRY);
catcher.catch(DX_SHADER_PIXEL);
catcher.catch(ELLIOTT_GRAND_SUPERCYCLE);
catcher.catch(ELLIOTT_SUPERCYCLE);
catcher.catch(ELLIOTT_CYCLE);
catcher.catch(ELLIOTT_PRIMARY);
catcher.catch(ELLIOTT_INTERMEDIATE);
catcher.catch(ELLIOTT_MINOR);
catcher.catch(ELLIOTT_MINUTE);
catcher.catch(ELLIOTT_MINUETTE);
catcher.catch(ELLIOTT_SUBMINUETTE);
catcher.catch(FSD_WRITE_FILE);
catcher.catch(FSD_SELECT_FOLDER);
catcher.catch(FSD_ALLOW_MULTISELECT);
catcher.catch(FSD_FILE_MUST_EXIST);
catcher.catch(FSD_COMMON_FOLDER);
catcher.catch(SEEK_SET);
catcher.catch(SEEK_CUR);
catcher.catch(SEEK_END);
catcher.catch(FILE_EXISTS);
catcher.catch(FILE_CREATE_DATE);
catcher.catch(FILE_MODIFY_DATE);
catcher.catch(FILE_ACCESS_DATE);
catcher.catch(FILE_SIZE);
catcher.catch(FILE_POSITION);
catcher.catch(FILE_END);
catcher.catch(FILE_LINE_END);
catcher.catch(FILE_IS_COMMON);
catcher.catch(FILE_IS_TEXT);
catcher.catch(FILE_IS_BINARY);
catcher.catch(FILE_IS_CSV);
catcher.catch(FILE_IS_ANSI);
catcher.catch(FILE_IS_READABLE);
catcher.catch(FILE_IS_WRITABLE);
catcher.catch(FP_SUBNORMAL);
catcher.catch(FP_NORMAL);
catcher.catch(FP_ZERO);
catcher.catch(FP_INFINITE);
catcher.catch(FP_NAN);
catcher.catch(GANN_UP_TREND);
catcher.catch(GANN_DOWN_TREND);
catcher.catch(INDICATOR_DATA);
catcher.catch(INDICATOR_COLOR_INDEX);
catcher.catch(INDICATOR_CALCULATIONS);
catcher.catch(IND_AC);
catcher.catch(IND_AD);
catcher.catch(IND_ALLIGATOR);
catcher.catch(IND_ADX);
catcher.catch(IND_ADXW);
catcher.catch(IND_ATR);
catcher.catch(IND_AO);
catcher.catch(IND_BEARS);
catcher.catch(IND_BANDS);
catcher.catch(IND_BULLS);
catcher.catch(IND_CCI);
catcher.catch(IND_DEMARKER);
catcher.catch(IND_ENVELOPES);
catcher.catch(IND_FORCE);
catcher.catch(IND_FRACTALS);
catcher.catch(IND_GATOR);
catcher.catch(IND_ICHIMOKU);
catcher.catch(IND_BWMFI);
catcher.catch(IND_MACD);
catcher.catch(IND_MOMENTUM);
catcher.catch(IND_MFI);
catcher.catch(IND_MA);
catcher.catch(IND_OSMA);
catcher.catch(IND_OBV);
catcher.catch(IND_SAR);
catcher.catch(IND_RSI);
catcher.catch(IND_RVI);
catcher.catch(IND_STDDEV);
catcher.catch(IND_STOCHASTIC);
catcher.catch(IND_VOLUMES);
catcher.catch(IND_WPR);
catcher.catch(IND_DEMA);
catcher.catch(IND_TEMA);
catcher.catch(IND_TRIX);
catcher.catch(IND_FRAMA);
catcher.catch(IND_AMA);
catcher.catch(IND_CHAIKIN);
catcher.catch(IND_VIDYA);
catcher.catch(IND_CUSTOM);
catcher.catch(INIT_SUCCEEDED);
catcher.catch(INIT_FAILED);
catcher.catch(INIT_PARAMETERS_INCORRECT);
catcher.catch(INIT_AGENT_NOT_SUITABLE);
catcher.catch(LICENSE_FREE);
catcher.catch(LICENSE_DEMO);
catcher.catch(LICENSE_FULL);
catcher.catch(LICENSE_TIME);
catcher.catch(STYLE_SOLID);
catcher.catch(STYLE_DASH);
catcher.catch(STYLE_DOT);
catcher.catch(STYLE_DASHDOT);
catcher.catch(STYLE_DASHDOTDOT);
catcher.catch(LOSS_MAE);
catcher.catch(LOSS_MSE);
catcher.catch(LOSS_CCE);
catcher.catch(LOSS_BCE);
catcher.catch(LOSS_MAPE);
catcher.catch(LOSS_MSLE);
catcher.catch(LOSS_KLD);
catcher.catch(LOSS_COSINE);
catcher.catch(LOSS_POISSON);
catcher.catch(LOSS_HINGE);
catcher.catch(LOSS_SQ_HINGE);
catcher.catch(LOSS_CAT_HINGE);
catcher.catch(LOSS_LOG_COSH);
catcher.catch(LOSS_HUBER);
catcher.catch(MATRIX_NORM_FROBENIUS);
catcher.catch(MATRIX_NORM_SPECTRAL);
catcher.catch(MATRIX_NORM_NUCLEAR);
catcher.catch(MATRIX_NORM_INF);
catcher.catch(MATRIX_NORM_P1);
catcher.catch(MATRIX_NORM_P2);
catcher.catch(MATRIX_NORM_MINUS_INF);
catcher.catch(MATRIX_NORM_MINUS_P1);
catcher.catch(MATRIX_NORM_MINUS_P2);
catcher.catch(MODE_SMA);
catcher.catch(MODE_EMA);
catcher.catch(MODE_SMMA);
catcher.catch(MODE_LWMA);
catcher.catch(MQL_PROGRAM_TYPE);
catcher.catch(MQL_DLLS_ALLOWED);
catcher.catch(MQL_TRADE_ALLOWED);
catcher.catch(MQL_DEBUG);
catcher.catch(MQL_TESTER);
catcher.catch(MQL_OPTIMIZATION);
catcher.catch(MQL_VISUAL_MODE);
catcher.catch(MQL_LICENSE_TYPE);
catcher.catch(MQL_PROFILER);
catcher.catch(MQL_MEMORY_USED);
catcher.catch(MQL_FRAME_MODE);
catcher.catch(MQL_MEMORY_LIMIT);
catcher.catch(MQL_SIGNALS_ALLOWED);
catcher.catch(MQL_CODEPAGE);
catcher.catch(MQL_FORWARD);
catcher.catch(MQL_HANDLES_USED);
catcher.catch(MQL_PROGRAM_NAME);
catcher.catch(MQL_PROGRAM_PATH);
catcher.catch(OBJ_VLINE);
catcher.catch(OBJ_HLINE);
catcher.catch(OBJ_TREND);
catcher.catch(OBJ_TRENDBYANGLE);
catcher.catch(OBJ_CYCLES);
catcher.catch(OBJ_CHANNEL);
catcher.catch(OBJ_STDDEVCHANNEL);
catcher.catch(OBJ_REGRESSION);
catcher.catch(OBJ_PITCHFORK);
catcher.catch(OBJ_GANNLINE);
catcher.catch(OBJ_GANNFAN);
catcher.catch(OBJ_GANNGRID);
catcher.catch(OBJ_FIBO);
catcher.catch(OBJ_FIBOTIMES);
catcher.catch(OBJ_FIBOFAN);
catcher.catch(OBJ_FIBOARC);
catcher.catch(OBJ_FIBOCHANNEL);
catcher.catch(OBJ_EXPANSION);
catcher.catch(OBJ_ELLIOTWAVE5);
catcher.catch(OBJ_ELLIOTWAVE3);
catcher.catch(OBJ_RECTANGLE);
catcher.catch(OBJ_TRIANGLE);
catcher.catch(OBJ_ELLIPSE);
catcher.catch(OBJ_ARROW_THUMB_UP);
catcher.catch(OBJ_ARROW_THUMB_DOWN);
catcher.catch(OBJ_ARROW_UP);
catcher.catch(OBJ_ARROW_DOWN);
catcher.catch(OBJ_ARROW_STOP);
catcher.catch(OBJ_ARROW_CHECK);
catcher.catch(OBJ_ARROW_LEFT_PRICE);
catcher.catch(OBJ_ARROW_RIGHT_PRICE);
catcher.catch(OBJ_ARROW_BUY);
catcher.catch(OBJ_ARROW_SELL);
catcher.catch(OBJ_ARROW);
catcher.catch(OBJ_TEXT);
catcher.catch(OBJ_LABEL);
catcher.catch(OBJ_BUTTON);
catcher.catch(OBJ_CHART);
catcher.catch(OBJ_BITMAP);
catcher.catch(OBJ_BITMAP_LABEL);
catcher.catch(OBJ_EDIT);
catcher.catch(OBJ_ARROWED_LINE);
catcher.catch(OBJ_EVENT);
catcher.catch(OBJ_RECTANGLE_LABEL);
catcher.catch(OBJPROP_PRICE);
catcher.catch(OBJPROP_LEVELVALUE);
catcher.catch(OBJPROP_SCALE);
catcher.catch(OBJPROP_ANGLE);
catcher.catch(OBJPROP_DEVIATION);
catcher.catch(OBJPROP_COLOR);
catcher.catch(OBJPROP_STYLE);
catcher.catch(OBJPROP_WIDTH);
catcher.catch(OBJPROP_BACK);
catcher.catch(OBJPROP_SELECTED);
catcher.catch(OBJPROP_TYPE);
catcher.catch(OBJPROP_TIME);
catcher.catch(OBJPROP_SELECTABLE);
catcher.catch(OBJPROP_CREATETIME);
catcher.catch(OBJPROP_TIMEFRAMES);
catcher.catch(OBJPROP_LEVELS);
catcher.catch(OBJPROP_LEVELCOLOR);
catcher.catch(OBJPROP_LEVELSTYLE);
catcher.catch(OBJPROP_LEVELWIDTH);
catcher.catch(OBJPROP_ZORDER);
catcher.catch(OBJPROP_HIDDEN);
catcher.catch(OBJPROP_FONTSIZE);
catcher.catch(OBJPROP_RAY_LEFT);
catcher.catch(OBJPROP_RAY_RIGHT);
catcher.catch(OBJPROP_ELLIPSE);
catcher.catch(OBJPROP_ARROWCODE);
catcher.catch(OBJPROP_ANCHOR);
catcher.catch(OBJPROP_XDISTANCE);
catcher.catch(OBJPROP_YDISTANCE);
catcher.catch(OBJPROP_DIRECTION);
catcher.catch(OBJPROP_DEGREE);
catcher.catch(OBJPROP_DRAWLINES);
catcher.catch(OBJPROP_STATE);
catcher.catch(OBJPROP_XSIZE);
catcher.catch(OBJPROP_YSIZE);
catcher.catch(OBJPROP_PERIOD);
catcher.catch(OBJPROP_DATE_SCALE);
catcher.catch(OBJPROP_PRICE_SCALE);
catcher.catch(OBJPROP_BGCOLOR);
catcher.catch(OBJPROP_CORNER);
catcher.catch(OBJPROP_CHART_SCALE);
catcher.catch(OBJPROP_READONLY);
catcher.catch(OBJPROP_BORDER_TYPE);
catcher.catch(OBJPROP_CHART_ID);
catcher.catch(OBJPROP_FILL);
catcher.catch(OBJPROP_RAY);
catcher.catch(OBJPROP_XOFFSET);
catcher.catch(OBJPROP_YOFFSET);
catcher.catch(OBJPROP_BORDER_COLOR);
catcher.catch(OBJPROP_ALIGN);
catcher.catch(OBJPROP_NAME);
catcher.catch(OBJPROP_TEXT);
catcher.catch(OBJPROP_LEVELTEXT);
catcher.catch(OBJPROP_TOOLTIP);
catcher.catch(OBJPROP_FONT);
catcher.catch(OBJPROP_BMPFILE);
catcher.catch(OBJPROP_SYMBOL);
catcher.catch(CL_UNKNOWN);
catcher.catch(CL_COMPLETE);
catcher.catch(CL_RUNNING);
catcher.catch(CL_SUBMITTED);
catcher.catch(CL_QUEUED);
catcher.catch(OPENCL_INVALID);
catcher.catch(OPENCL_CONTEXT);
catcher.catch(OPENCL_PROGRAM);
catcher.catch(OPENCL_KERNEL);
catcher.catch(OPENCL_BUFFER);
catcher.catch(CL_LAST_ERROR);
catcher.catch(CL_DEVICE_COUNT);
catcher.catch(CL_DEVICE_TYPE);
catcher.catch(CL_DEVICE_VENDOR_ID);
catcher.catch(CL_DEVICE_MAX_COMPUTE_UNITS);
catcher.catch(CL_DEVICE_MAX_WORK_ITEM_DIMENSIONS);
catcher.catch(CL_DEVICE_MAX_WORK_GROUP_SIZE);
catcher.catch(CL_DEVICE_MAX_WORK_ITEM_SIZES);
catcher.catch(CL_DEVICE_MAX_CLOCK_FREQUENCY);
catcher.catch(CL_DEVICE_GLOBAL_MEM_SIZE);
catcher.catch(CL_DEVICE_LOCAL_MEM_SIZE);
catcher.catch(CL_DEVICE_DOUBLE_FP_CONFIG);
catcher.catch(CL_BUFFER_SIZE);
catcher.catch(CL_KERNEL_WORK_GROUP_SIZE);
catcher.catch(CL_KERNEL_LOCAL_MEM_SIZE);
catcher.catch(CL_KERNEL_PRIVATE_MEM_SIZE);
catcher.catch(CL_PLATFORM_PROFILE);
catcher.catch(CL_PLATFORM_VERSION);
catcher.catch(CL_PLATFORM_NAME);
catcher.catch(CL_PLATFORM_VENDOR);
catcher.catch(CL_PLATFORM_EXTENSIONS);
catcher.catch(CL_ERROR_DESCRIPTION);
catcher.catch(CL_DEVICE_NAME);
catcher.catch(CL_DEVICE_VENDOR);
catcher.catch(CL_DRIVER_VERSION);
catcher.catch(CL_DEVICE_PROFILE);
catcher.catch(CL_DEVICE_VERSION);
catcher.catch(CL_DEVICE_EXTENSIONS);
catcher.catch(CL_DEVICE_OPENCL_C_VERSION);
catcher.catch(CL_DEVICE_BUILT_IN_KERNELS);
catcher.catch(ORDER_VOLUME_INITIAL);
catcher.catch(ORDER_VOLUME_CURRENT);
catcher.catch(ORDER_PRICE_OPEN);
catcher.catch(ORDER_PRICE_CURRENT);
catcher.catch(ORDER_PRICE_STOPLIMIT);
catcher.catch(ORDER_SL);
catcher.catch(ORDER_TP);
catcher.catch(ORDER_TIME_SETUP);
catcher.catch(ORDER_TIME_EXPIRATION);
catcher.catch(ORDER_TIME_DONE);
catcher.catch(ORDER_TYPE);
catcher.catch(ORDER_TYPE_FILLING);
catcher.catch(ORDER_TYPE_TIME);
catcher.catch(ORDER_STATE);
catcher.catch(ORDER_MAGIC);
catcher.catch(ORDER_POSITION_ID);
catcher.catch(ORDER_TIME_SETUP_MSC);
catcher.catch(ORDER_TIME_DONE_MSC);
catcher.catch(ORDER_POSITION_BY_ID);
catcher.catch(ORDER_TICKET);
catcher.catch(ORDER_REASON);
catcher.catch(ORDER_SYMBOL);
catcher.catch(ORDER_COMMENT);
catcher.catch(ORDER_EXTERNAL_ID);
catcher.catch(ORDER_REASON_CLIENT);
catcher.catch(ORDER_REASON_MOBILE);
catcher.catch(ORDER_REASON_WEB);
catcher.catch(ORDER_REASON_EXPERT);
catcher.catch(ORDER_REASON_SL);
catcher.catch(ORDER_REASON_TP);
catcher.catch(ORDER_REASON_SO);
catcher.catch(ORDER_STATE_STARTED);
catcher.catch(ORDER_STATE_PLACED);
catcher.catch(ORDER_STATE_CANCELED);
catcher.catch(ORDER_STATE_PARTIAL);
catcher.catch(ORDER_STATE_FILLED);
catcher.catch(ORDER_STATE_REJECTED);
catcher.catch(ORDER_STATE_EXPIRED);
catcher.catch(ORDER_STATE_REQUEST_ADD);
catcher.catch(ORDER_STATE_REQUEST_MODIFY);
catcher.catch(ORDER_STATE_REQUEST_CANCEL);
catcher.catch(ORDER_TYPE_BUY);
catcher.catch(ORDER_TYPE_SELL);
catcher.catch(ORDER_TYPE_BUY_LIMIT);
catcher.catch(ORDER_TYPE_SELL_LIMIT);
catcher.catch(ORDER_TYPE_BUY_STOP);
catcher.catch(ORDER_TYPE_SELL_STOP);
catcher.catch(ORDER_TYPE_BUY_STOP_LIMIT);
catcher.catch(ORDER_TYPE_SELL_STOP_LIMIT);
catcher.catch(ORDER_TYPE_CLOSE_BY);
catcher.catch(ORDER_FILLING_FOK);
catcher.catch(ORDER_FILLING_IOC);
catcher.catch(ORDER_FILLING_RETURN);
catcher.catch(ORDER_TIME_GTC);
catcher.catch(ORDER_TIME_DAY);
catcher.catch(ORDER_TIME_SPECIFIED);
catcher.catch(ORDER_TIME_SPECIFIED_DAY);
catcher.catch(PLOT_EMPTY_VALUE);
catcher.catch(PLOT_ARROW);
catcher.catch(PLOT_ARROW_SHIFT);
catcher.catch(PLOT_DRAW_BEGIN);
catcher.catch(PLOT_DRAW_TYPE);
catcher.catch(PLOT_SHOW_DATA);
catcher.catch(PLOT_SHIFT);
catcher.catch(PLOT_LINE_STYLE);
catcher.catch(PLOT_LINE_WIDTH);
catcher.catch(PLOT_COLOR_INDEXES);
catcher.catch(PLOT_LINE_COLOR);
catcher.catch(PLOT_LABEL);
catcher.catch(POINTER_INVALID);
catcher.catch(POINTER_DYNAMIC);
catcher.catch(POINTER_AUTOMATIC);
catcher.catch(POSITION_VOLUME);
catcher.catch(POSITION_PRICE_OPEN);
catcher.catch(POSITION_PRICE_CURRENT);
catcher.catch(POSITION_SL);
catcher.catch(POSITION_TP);
catcher.catch(POSITION_COMMISSION);
catcher.catch(POSITION_SWAP);
catcher.catch(POSITION_PROFIT);
catcher.catch(POSITION_TIME);
catcher.catch(POSITION_TYPE);
catcher.catch(POSITION_MAGIC);
catcher.catch(POSITION_IDENTIFIER);
catcher.catch(POSITION_TIME_MSC);
catcher.catch(POSITION_TIME_UPDATE);
catcher.catch(POSITION_TIME_UPDATE_MSC);
catcher.catch(POSITION_TICKET);
catcher.catch(POSITION_REASON);
catcher.catch(POSITION_SYMBOL);
catcher.catch(POSITION_COMMENT);
catcher.catch(POSITION_EXTERNAL_ID);
catcher.catch(POSITION_REASON_CLIENT);
catcher.catch(POSITION_REASON_MOBILE);
catcher.catch(POSITION_REASON_WEB);
catcher.catch(POSITION_REASON_EXPERT);
catcher.catch(POSITION_TYPE_BUY);
catcher.catch(POSITION_TYPE_SELL);
catcher.catch(PROGRAM_SCRIPT);
catcher.catch(PROGRAM_EXPERT);
catcher.catch(PROGRAM_INDICATOR);
catcher.catch(PROGRAM_SERVICE);
catcher.catch(REGRESSION_MAE);
catcher.catch(REGRESSION_MSE);
catcher.catch(REGRESSION_RMSE);
catcher.catch(REGRESSION_R2);
catcher.catch(REGRESSION_MAPE);
catcher.catch(REGRESSION_MSPE);
catcher.catch(REGRESSION_RMSLE);
catcher.catch(MODE_OPEN);
catcher.catch(MODE_LOW);
catcher.catch(MODE_HIGH);
catcher.catch(MODE_CLOSE);
catcher.catch(MODE_VOLUME);
catcher.catch(MODE_SPREAD);
catcher.catch(MODE_REAL_VOLUME);
catcher.catch(SERIES_BARS_COUNT);
catcher.catch(SERIES_FIRSTDATE);
catcher.catch(SERIES_SERVER_FIRSTDATE);
catcher.catch(SERIES_TERMINAL_FIRSTDATE);
catcher.catch(SERIES_SYNCHRONIZED);
catcher.catch(SERIES_LASTBAR_DATE);
catcher.catch(SIGNAL_BASE_PRICE);
catcher.catch(SIGNAL_BASE_GAIN);
catcher.catch(SIGNAL_BASE_BALANCE);
catcher.catch(SIGNAL_BASE_MAX_DRAWDOWN);
catcher.catch(SIGNAL_BASE_EQUITY);
catcher.catch(SIGNAL_BASE_ROI);
catcher.catch(SIGNAL_BASE_ID);
catcher.catch(SIGNAL_BASE_DATE_PUBLISHED);
catcher.catch(SIGNAL_BASE_DATE_STARTED);
catcher.catch(SIGNAL_BASE_DATE_UPDATED);
catcher.catch(SIGNAL_BASE_SUBSCRIBERS);
catcher.catch(SIGNAL_BASE_TRADE_MODE);
catcher.catch(SIGNAL_BASE_LEVERAGE);
catcher.catch(SIGNAL_BASE_TRADES);
catcher.catch(SIGNAL_BASE_PIPS);
catcher.catch(SIGNAL_BASE_RATING);
catcher.catch(SIGNAL_BASE_BROKER);
catcher.catch(SIGNAL_BASE_BROKER_SERVER);
catcher.catch(SIGNAL_BASE_NAME);
catcher.catch(SIGNAL_BASE_AUTHOR_LOGIN);
catcher.catch(SIGNAL_BASE_CURRENCY);
catcher.catch(SIGNAL_INFO_VOLUME_PERCENT);
catcher.catch(SIGNAL_INFO_EQUITY_LIMIT);
catcher.catch(SIGNAL_INFO_SLIPPAGE);
catcher.catch(SIGNAL_INFO_ID);
catcher.catch(SIGNAL_INFO_SUBSCRIPTION_ENABLED);
catcher.catch(SIGNAL_INFO_TERMS_AGREE);
catcher.catch(SIGNAL_INFO_COPY_SLTP);
catcher.catch(SIGNAL_INFO_CONFIRMATIONS_DISABLED);
catcher.catch(SIGNAL_INFO_DEPOSIT_PERCENT);
catcher.catch(SIGNAL_INFO_NAME);
catcher.catch(SORT_ASCENDING);
catcher.catch(SORT_DESCENDING);
catcher.catch(STAT_INITIAL_DEPOSIT);
catcher.catch(STAT_WITHDRAWAL);
catcher.catch(STAT_PROFIT);
catcher.catch(STAT_GROSS_PROFIT);
catcher.catch(STAT_GROSS_LOSS);
catcher.catch(STAT_MAX_PROFITTRADE);
catcher.catch(STAT_MAX_LOSSTRADE);
catcher.catch(STAT_CONPROFITMAX);
catcher.catch(STAT_MAX_CONWINS);
catcher.catch(STAT_CONLOSSMAX);
catcher.catch(STAT_MAX_CONLOSSES);
catcher.catch(STAT_BALANCEMIN);
catcher.catch(STAT_BALANCE_DD);
catcher.catch(STAT_BALANCEDD_PERCENT);
catcher.catch(STAT_BALANCE_DD_RELATIVE);
catcher.catch(STAT_BALANCE_DDREL_PERCENT);
catcher.catch(STAT_EQUITYMIN);
catcher.catch(STAT_EQUITY_DD);
catcher.catch(STAT_EQUITYDD_PERCENT);
catcher.catch(STAT_EQUITY_DD_RELATIVE);
catcher.catch(STAT_EQUITY_DDREL_PERCENT);
catcher.catch(STAT_EXPECTED_PAYOFF);
catcher.catch(STAT_PROFIT_FACTOR);
catcher.catch(STAT_RECOVERY_FACTOR);
catcher.catch(STAT_SHARPE_RATIO);
catcher.catch(STAT_MIN_MARGINLEVEL);
catcher.catch(STAT_CUSTOM_ONTESTER);
catcher.catch(STAT_DEALS);
catcher.catch(STAT_TRADES);
catcher.catch(STAT_PROFIT_TRADES);
catcher.catch(STAT_LOSS_TRADES);
catcher.catch(STAT_SHORT_TRADES);
catcher.catch(STAT_LONG_TRADES);
catcher.catch(STAT_PROFIT_SHORTTRADES);
catcher.catch(STAT_PROFIT_LONGTRADES);
catcher.catch(STAT_CONPROFITMAX_TRADES);
catcher.catch(STAT_MAX_CONPROFIT_TRADES);
catcher.catch(STAT_CONLOSSMAX_TRADES);
catcher.catch(STAT_MAX_CONLOSS_TRADES);
catcher.catch(STAT_PROFITTRADES_AVGCON);
catcher.catch(STAT_LOSSTRADES_AVGCON);
catcher.catch(STO_LOWHIGH);
catcher.catch(STO_CLOSECLOSE);
catcher.catch(SYMBOL_CALC_MODE_FOREX);
catcher.catch(SYMBOL_CALC_MODE_FUTURES);
catcher.catch(SYMBOL_CALC_MODE_CFD);
catcher.catch(SYMBOL_CALC_MODE_CFDINDEX);
catcher.catch(SYMBOL_CALC_MODE_CFDLEVERAGE);
catcher.catch(SYMBOL_CALC_MODE_FOREX_NO_LEVERAGE);
catcher.catch(SYMBOL_CALC_MODE_EXCH_STOCKS);
catcher.catch(SYMBOL_CALC_MODE_EXCH_FUTURES);
catcher.catch(SYMBOL_CALC_MODE_EXCH_OPTIONS);
catcher.catch(SYMBOL_CALC_MODE_EXCH_OPTIONS_MARGIN);
catcher.catch(SYMBOL_CALC_MODE_EXCH_BONDS);
catcher.catch(SYMBOL_CALC_MODE_EXCH_STOCKS_MOEX);
catcher.catch(SYMBOL_CALC_MODE_EXCH_BONDS_MOEX);
catcher.catch(SYMBOL_CALC_MODE_SERV_COLLATERAL);
catcher.catch(SYMBOL_CHART_MODE_BID);
catcher.catch(SYMBOL_CHART_MODE_LAST);
catcher.catch(SYMBOL_CHART_MODE_OLD);
catcher.catch(INDUSTRY_UNDEFINED);
catcher.catch(INDUSTRY_AGRICULTURAL_INPUTS);
catcher.catch(INDUSTRY_ALUMINIUM);
catcher.catch(INDUSTRY_BUILDING_MATERIALS);
catcher.catch(INDUSTRY_CHEMICALS);
catcher.catch(INDUSTRY_COKING_COAL);
catcher.catch(INDUSTRY_COPPER);
catcher.catch(INDUSTRY_GOLD);
catcher.catch(INDUSTRY_LUMBER_WOOD);
catcher.catch(INDUSTRY_INDUSTRIAL_METALS);
catcher.catch(INDUSTRY_PRECIOUS_METALS);
catcher.catch(INDUSTRY_PAPER);
catcher.catch(INDUSTRY_SILVER);
catcher.catch(INDUSTRY_SPECIALTY_CHEMICALS);
catcher.catch(INDUSTRY_STEEL);
catcher.catch(INDUSTRY_ADVERTISING);
catcher.catch(INDUSTRY_BROADCASTING);
catcher.catch(INDUSTRY_GAMING_MULTIMEDIA);
catcher.catch(INDUSTRY_ENTERTAINMENT);
catcher.catch(INDUSTRY_INTERNET_CONTENT);
catcher.catch(INDUSTRY_PUBLISHING);
catcher.catch(INDUSTRY_TELECOM);
catcher.catch(INDUSTRY_APPAREL_MANUFACTURING);
catcher.catch(INDUSTRY_APPAREL_RETAIL);
catcher.catch(INDUSTRY_AUTO_MANUFACTURERS);
catcher.catch(INDUSTRY_AUTO_PARTS);
catcher.catch(INDUSTRY_AUTO_DEALERSHIP);
catcher.catch(INDUSTRY_DEPARTMENT_STORES);
catcher.catch(INDUSTRY_FOOTWEAR_ACCESSORIES);
catcher.catch(INDUSTRY_FURNISHINGS);
catcher.catch(INDUSTRY_GAMBLING);
catcher.catch(INDUSTRY_HOME_IMPROV_RETAIL);
catcher.catch(INDUSTRY_INTERNET_RETAIL);
catcher.catch(INDUSTRY_LEISURE);
catcher.catch(INDUSTRY_LODGING);
catcher.catch(INDUSTRY_LUXURY_GOODS);
catcher.catch(INDUSTRY_PACKAGING_CONTAINERS);
catcher.catch(INDUSTRY_PERSONAL_SERVICES);
catcher.catch(INDUSTRY_RECREATIONAL_VEHICLES);
catcher.catch(INDUSTRY_RESIDENT_CONSTRUCTION);
catcher.catch(INDUSTRY_RESORTS_CASINOS);
catcher.catch(INDUSTRY_RESTAURANTS);
catcher.catch(INDUSTRY_SPECIALTY_RETAIL);
catcher.catch(INDUSTRY_TEXTILE_MANUFACTURING);
catcher.catch(INDUSTRY_TRAVEL_SERVICES);
catcher.catch(INDUSTRY_BEVERAGES_BREWERS);
catcher.catch(INDUSTRY_BEVERAGES_NON_ALCO);
catcher.catch(INDUSTRY_BEVERAGES_WINERIES);
catcher.catch(INDUSTRY_CONFECTIONERS);
catcher.catch(INDUSTRY_DISCOUNT_STORES);
catcher.catch(INDUSTRY_EDUCATION_TRAINIG);
catcher.catch(INDUSTRY_FARM_PRODUCTS);
catcher.catch(INDUSTRY_FOOD_DISTRIBUTION);
catcher.catch(INDUSTRY_GROCERY_STORES);
catcher.catch(INDUSTRY_HOUSEHOLD_PRODUCTS);
catcher.catch(INDUSTRY_PACKAGED_FOODS);
catcher.catch(INDUSTRY_TOBACCO);
catcher.catch(INDUSTRY_OIL_GAS_DRILLING);
catcher.catch(INDUSTRY_OIL_GAS_EP);
catcher.catch(INDUSTRY_OIL_GAS_EQUIPMENT);
catcher.catch(INDUSTRY_OIL_GAS_INTEGRATED);
catcher.catch(INDUSTRY_OIL_GAS_MIDSTREAM);
catcher.catch(INDUSTRY_OIL_GAS_REFINING);
catcher.catch(INDUSTRY_THERMAL_COAL);
catcher.catch(INDUSTRY_URANIUM);
catcher.catch(INDUSTRY_EXCHANGE_TRADED_FUND);
catcher.catch(INDUSTRY_ASSETS_MANAGEMENT);
catcher.catch(INDUSTRY_BANKS_DIVERSIFIED);
catcher.catch(INDUSTRY_BANKS_REGIONAL);
catcher.catch(INDUSTRY_CAPITAL_MARKETS);
catcher.catch(INDUSTRY_CLOSE_END_FUND_DEBT);
catcher.catch(INDUSTRY_CLOSE_END_FUND_EQUITY);
catcher.catch(INDUSTRY_CLOSE_END_FUND_FOREIGN);
catcher.catch(INDUSTRY_CREDIT_SERVICES);
catcher.catch(INDUSTRY_FINANCIAL_CONGLOMERATE);
catcher.catch(INDUSTRY_FINANCIAL_DATA_EXCHANGE);
catcher.catch(INDUSTRY_INSURANCE_BROKERS);
catcher.catch(INDUSTRY_INSURANCE_DIVERSIFIED);
catcher.catch(INDUSTRY_INSURANCE_LIFE);
catcher.catch(INDUSTRY_INSURANCE_PROPERTY);
catcher.catch(INDUSTRY_INSURANCE_REINSURANCE);
catcher.catch(INDUSTRY_INSURANCE_SPECIALTY);
catcher.catch(INDUSTRY_MORTGAGE_FINANCE);
catcher.catch(INDUSTRY_SHELL_COMPANIES);
catcher.catch(INDUSTRY_BIOTECHNOLOGY);
catcher.catch(INDUSTRY_DIAGNOSTICS_RESEARCH);
catcher.catch(INDUSTRY_DRUGS_MANUFACTURERS);
catcher.catch(INDUSTRY_DRUGS_MANUFACTURERS_SPEC);
catcher.catch(INDUSTRY_HEALTHCARE_PLANS);
catcher.catch(INDUSTRY_HEALTH_INFORMATION);
catcher.catch(INDUSTRY_MEDICAL_FACILITIES);
catcher.catch(INDUSTRY_MEDICAL_DEVICES);
catcher.catch(INDUSTRY_MEDICAL_DISTRIBUTION);
catcher.catch(INDUSTRY_MEDICAL_INSTRUMENTS);
catcher.catch(INDUSTRY_PHARM_RETAILERS);
catcher.catch(INDUSTRY_AEROSPACE_DEFENSE);
catcher.catch(INDUSTRY_AIRLINES);
catcher.catch(INDUSTRY_AIRPORTS_SERVICES);
catcher.catch(INDUSTRY_BUILDING_PRODUCTS);
catcher.catch(INDUSTRY_BUSINESS_EQUIPMENT);
catcher.catch(INDUSTRY_CONGLOMERATES);
catcher.catch(INDUSTRY_CONSULTING_SERVICES);
catcher.catch(INDUSTRY_ELECTRICAL_EQUIPMENT);
catcher.catch(INDUSTRY_ENGINEERING_CONSTRUCTION);
catcher.catch(INDUSTRY_FARM_HEAVY_MACHINERY);
catcher.catch(INDUSTRY_INDUSTRIAL_DISTRIBUTION);
catcher.catch(INDUSTRY_INFRASTRUCTURE_OPERATIONS);
catcher.catch(INDUSTRY_FREIGHT_LOGISTICS);
catcher.catch(INDUSTRY_MARINE_SHIPPING);
catcher.catch(INDUSTRY_METAL_FABRICATION);
catcher.catch(INDUSTRY_POLLUTION_CONTROL);
catcher.catch(INDUSTRY_RAILROADS);
catcher.catch(INDUSTRY_RENTAL_LEASING);
catcher.catch(INDUSTRY_SECURITY_PROTECTION);
catcher.catch(INDUSTRY_SPEALITY_BUSINESS_SERVICES);
catcher.catch(INDUSTRY_SPEALITY_MACHINERY);
catcher.catch(INDUSTRY_STUFFING_EMPLOYMENT);
catcher.catch(INDUSTRY_TOOLS_ACCESSORIES);
catcher.catch(INDUSTRY_TRUCKING);
catcher.catch(INDUSTRY_WASTE_MANAGEMENT);
catcher.catch(INDUSTRY_REAL_ESTATE_DEVELOPMENT);
catcher.catch(INDUSTRY_REAL_ESTATE_DIVERSIFIED);
catcher.catch(INDUSTRY_REAL_ESTATE_SERVICES);
catcher.catch(INDUSTRY_REIT_DIVERSIFIED);
catcher.catch(INDUSTRY_REIT_HEALTCARE);
catcher.catch(INDUSTRY_REIT_HOTEL_MOTEL);
catcher.catch(INDUSTRY_REIT_INDUSTRIAL);
catcher.catch(INDUSTRY_REIT_MORTAGE);
catcher.catch(INDUSTRY_REIT_OFFICE);
catcher.catch(INDUSTRY_REIT_RESIDENTAL);
catcher.catch(INDUSTRY_REIT_RETAIL);
catcher.catch(INDUSTRY_REIT_SPECIALITY);
catcher.catch(INDUSTRY_COMMUNICATION_EQUIPMENT);
catcher.catch(INDUSTRY_COMPUTER_HARDWARE);
catcher.catch(INDUSTRY_CONSUMER_ELECTRONICS);
catcher.catch(INDUSTRY_ELECTRONIC_COMPONENTS);
catcher.catch(INDUSTRY_ELECTRONIC_DISTRIBUTION);
catcher.catch(INDUSTRY_IT_SERVICES);
catcher.catch(INDUSTRY_SCIENTIFIC_INSTRUMENTS);
catcher.catch(INDUSTRY_SEMICONDUCTOR_EQUIPMENT);
catcher.catch(INDUSTRY_SEMICONDUCTORS);
catcher.catch(INDUSTRY_SOFTWARE_APPLICATION);
catcher.catch(INDUSTRY_SOFTWARE_INFRASTRUCTURE);
catcher.catch(INDUSTRY_SOLAR);
catcher.catch(INDUSTRY_UTILITIES_DIVERSIFIED);
catcher.catch(INDUSTRY_UTILITIES_POWERPRODUCERS);
catcher.catch(INDUSTRY_UTILITIES_RENEWABLE);
catcher.catch(INDUSTRY_UTILITIES_REGULATED_ELECTRIC);
catcher.catch(INDUSTRY_UTILITIES_REGULATED_GAS);
catcher.catch(INDUSTRY_UTILITIES_REGULATED_WATER);
catcher.catch(INDUSTRY_COMMODITIES_AGRICULTURAL);
catcher.catch(INDUSTRY_COMMODITIES_ENERGY);
catcher.catch(INDUSTRY_COMMODITIES_METALS);
catcher.catch(INDUSTRY_COMMODITIES_PRECIOUS);
catcher.catch(SYMBOL_BID);
catcher.catch(SYMBOL_BIDHIGH);
catcher.catch(SYMBOL_BIDLOW);
catcher.catch(SYMBOL_ASK);
catcher.catch(SYMBOL_ASKHIGH);
catcher.catch(SYMBOL_ASKLOW);
catcher.catch(SYMBOL_LAST);
catcher.catch(SYMBOL_LASTHIGH);
catcher.catch(SYMBOL_LASTLOW);
catcher.catch(SYMBOL_VOLUME_REAL);
catcher.catch(SYMBOL_VOLUMEHIGH_REAL);
catcher.catch(SYMBOL_VOLUMELOW_REAL);
catcher.catch(SYMBOL_POINT);
catcher.catch(SYMBOL_TRADE_TICK_VALUE);
catcher.catch(SYMBOL_TRADE_TICK_SIZE);
catcher.catch(SYMBOL_TRADE_CONTRACT_SIZE);
catcher.catch(SYMBOL_VOLUME_MIN);
catcher.catch(SYMBOL_VOLUME_MAX);
catcher.catch(SYMBOL_VOLUME_STEP);
catcher.catch(SYMBOL_SWAP_LONG);
catcher.catch(SYMBOL_SWAP_SHORT);
catcher.catch(SYMBOL_MARGIN_INITIAL);
catcher.catch(SYMBOL_MARGIN_MAINTENANCE);
catcher.catch(SYMBOL_MARGIN_LONG);
catcher.catch(SYMBOL_MARGIN_SHORT);
catcher.catch(SYMBOL_MARGIN_LIMIT);
catcher.catch(SYMBOL_MARGIN_STOP);
catcher.catch(SYMBOL_MARGIN_STOPLIMIT);
catcher.catch(SYMBOL_TRADE_TICK_VALUE_PROFIT);
catcher.catch(SYMBOL_TRADE_TICK_VALUE_LOSS);
catcher.catch(SYMBOL_VOLUME_LIMIT);
catcher.catch(SYMBOL_SESSION_VOLUME);
catcher.catch(SYMBOL_SESSION_TURNOVER);
catcher.catch(SYMBOL_SESSION_INTEREST);
catcher.catch(SYMBOL_SESSION_BUY_ORDERS_VOLUME);
catcher.catch(SYMBOL_SESSION_SELL_ORDERS_VOLUME);
catcher.catch(SYMBOL_SESSION_OPEN);
catcher.catch(SYMBOL_SESSION_CLOSE);
catcher.catch(SYMBOL_SESSION_AW);
catcher.catch(SYMBOL_SESSION_PRICE_SETTLEMENT);
catcher.catch(SYMBOL_SESSION_PRICE_LIMIT_MIN);
catcher.catch(SYMBOL_SESSION_PRICE_LIMIT_MAX);
catcher.catch(SYMBOL_OPTION_STRIKE);
catcher.catch(SYMBOL_MARGIN_HEDGED);
catcher.catch(SYMBOL_TRADE_LIQUIDITY_RATE);
catcher.catch(SYMBOL_TRADE_FACE_VALUE);
catcher.catch(SYMBOL_TRADE_ACCRUED_INTEREST);
catcher.catch(SYMBOL_PRICE_CHANGE);
catcher.catch(SYMBOL_PRICE_VOLATILITY);
catcher.catch(SYMBOL_PRICE_THEORETICAL);
catcher.catch(SYMBOL_PRICE_DELTA);
catcher.catch(SYMBOL_PRICE_THETA);
catcher.catch(SYMBOL_PRICE_GAMMA);
catcher.catch(SYMBOL_PRICE_VEGA);
catcher.catch(SYMBOL_PRICE_RHO);
catcher.catch(SYMBOL_PRICE_OMEGA);
catcher.catch(SYMBOL_PRICE_SENSITIVITY);
catcher.catch(SYMBOL_SWAP_SUNDAY);
catcher.catch(SYMBOL_SWAP_MONDAY);
catcher.catch(SYMBOL_SWAP_TUESDAY);
catcher.catch(SYMBOL_SWAP_WEDNESDAY);
catcher.catch(SYMBOL_SWAP_THURSDAY);
catcher.catch(SYMBOL_SWAP_FRIDAY);
catcher.catch(SYMBOL_SWAP_SATURDAY);
catcher.catch(SYMBOL_SELECT);
catcher.catch(SYMBOL_VOLUME);
catcher.catch(SYMBOL_VOLUMEHIGH);
catcher.catch(SYMBOL_VOLUMELOW);
catcher.catch(SYMBOL_TIME);
catcher.catch(SYMBOL_DIGITS);
catcher.catch(SYMBOL_SPREAD);
catcher.catch(SYMBOL_TICKS_BOOKDEPTH);
catcher.catch(SYMBOL_TRADE_CALC_MODE);
catcher.catch(SYMBOL_TRADE_MODE);
catcher.catch(SYMBOL_TRADE_STOPS_LEVEL);
catcher.catch(SYMBOL_TRADE_FREEZE_LEVEL);
catcher.catch(SYMBOL_TRADE_EXEMODE);
catcher.catch(SYMBOL_SWAP_MODE);
catcher.catch(SYMBOL_SWAP_ROLLOVER3DAYS);
catcher.catch(SYMBOL_SPREAD_FLOAT);
catcher.catch(SYMBOL_EXPIRATION_MODE);
catcher.catch(SYMBOL_FILLING_MODE);
catcher.catch(SYMBOL_START_TIME);
catcher.catch(SYMBOL_EXPIRATION_TIME);
catcher.catch(SYMBOL_SESSION_DEALS);
catcher.catch(SYMBOL_SESSION_BUY_ORDERS);
catcher.catch(SYMBOL_SESSION_SELL_ORDERS);
catcher.catch(SYMBOL_ORDER_MODE);
catcher.catch(SYMBOL_OPTION_RIGHT);
catcher.catch(SYMBOL_OPTION_MODE);
catcher.catch(SYMBOL_VISIBLE);
catcher.catch(SYMBOL_CUSTOM);
catcher.catch(SYMBOL_BACKGROUND_COLOR);
catcher.catch(SYMBOL_CHART_MODE);
catcher.catch(SYMBOL_ORDER_GTC_MODE);
catcher.catch(SYMBOL_MARGIN_HEDGED_USE_LEG);
catcher.catch(SYMBOL_IS_EXIST);
catcher.catch(SYMBOL_TIME_MSC);
catcher.catch(SYMBOL_SECTOR);
catcher.catch(SYMBOL_INDUSTRY);
catcher.catch(SYMBOL_SUBSCRIPTION_DELAY);
catcher.catch(SYMBOL_BANK);
catcher.catch(SYMBOL_DESCRIPTION);
catcher.catch(SYMBOL_PATH);
catcher.catch(SYMBOL_CURRENCY_BASE);
catcher.catch(SYMBOL_CURRENCY_PROFIT);
catcher.catch(SYMBOL_CURRENCY_MARGIN);
catcher.catch(SYMBOL_ISIN);
catcher.catch(SYMBOL_BASIS);
catcher.catch(SYMBOL_PAGE);
catcher.catch(SYMBOL_FORMULA);
catcher.catch(SYMBOL_CATEGORY);
catcher.catch(SYMBOL_EXCHANGE);
catcher.catch(SYMBOL_COUNTRY);
catcher.catch(SYMBOL_SECTOR_NAME);
catcher.catch(SYMBOL_INDUSTRY_NAME);
catcher.catch(SYMBOL_OPTION_MODE_EUROPEAN);
catcher.catch(SYMBOL_OPTION_MODE_AMERICAN);
catcher.catch(SYMBOL_OPTION_RIGHT_CALL);
catcher.catch(SYMBOL_OPTION_RIGHT_PUT);
catcher.catch(SYMBOL_ORDERS_GTC);
catcher.catch(SYMBOL_ORDERS_DAILY);
catcher.catch(SYMBOL_ORDERS_DAILY_EXCLUDING_STOPS);
catcher.catch(SECTOR_UNDEFINED);
catcher.catch(SECTOR_BASIC_MATERIALS);
catcher.catch(SECTOR_COMMUNICATION_SERVICES);
catcher.catch(SECTOR_CONSUMER_CYCLICAL);
catcher.catch(SECTOR_CONSUMER_DEFENSIVE);
catcher.catch(SECTOR_ENERGY);
catcher.catch(SECTOR_FINANCIAL);
catcher.catch(SECTOR_HEALTHCARE);
catcher.catch(SECTOR_INDUSTRIALS);
catcher.catch(SECTOR_REAL_ESTATE);
catcher.catch(SECTOR_TECHNOLOGY);
catcher.catch(SECTOR_UTILITIES);
catcher.catch(SECTOR_CURRENCY);
catcher.catch(SECTOR_CURRENCY_CRYPTO);
catcher.catch(SECTOR_INDEXES);
catcher.catch(SECTOR_COMMODITIES);
catcher.catch(SYMBOL_SWAP_MODE_DISABLED);
catcher.catch(SYMBOL_SWAP_MODE_POINTS);
catcher.catch(SYMBOL_SWAP_MODE_CURRENCY_SYMBOL);
catcher.catch(SYMBOL_SWAP_MODE_BY_INTEREST);
catcher.catch(SYMBOL_SWAP_MODE_CURRENCY_DEPOSIT);
catcher.catch(SYMBOL_SWAP_MODE_INTEREST_CURRENT);
catcher.catch(SYMBOL_SWAP_MODE_INTEREST_OPEN);
catcher.catch(SYMBOL_SWAP_MODE_REOPEN_CURRENT);
catcher.catch(SYMBOL_SWAP_MODE_REOPEN_BID);
catcher.catch(SYMBOL_TRADE_EXECUTION_REQUEST);
catcher.catch(SYMBOL_TRADE_EXECUTION_INSTANT);
catcher.catch(SYMBOL_TRADE_EXECUTION_MARKET);
catcher.catch(SYMBOL_TRADE_EXECUTION_EXCHANGE);
catcher.catch(SYMBOL_TRADE_MODE_DISABLED);
catcher.catch(SYMBOL_TRADE_MODE_LONGONLY);
catcher.catch(SYMBOL_TRADE_MODE_SHORTONLY);
catcher.catch(SYMBOL_TRADE_MODE_CLOSEONLY);
catcher.catch(SYMBOL_TRADE_MODE_FULL);
catcher.catch(TERMINAL_COMMUNITY_BALANCE);
catcher.catch(TERMINAL_RETRANSMISSION);
catcher.catch(TERMINAL_BUILD);
catcher.catch(TERMINAL_CONNECTED);
catcher.catch(TERMINAL_DLLS_ALLOWED);
catcher.catch(TERMINAL_TRADE_ALLOWED);
catcher.catch(TERMINAL_EMAIL_ENABLED);
catcher.catch(TERMINAL_FTP_ENABLED);
catcher.catch(TERMINAL_MAXBARS);
catcher.catch(TERMINAL_CODEPAGE);
catcher.catch(TERMINAL_MEMORY_PHYSICAL);
catcher.catch(TERMINAL_MEMORY_TOTAL);
catcher.catch(TERMINAL_MEMORY_AVAILABLE);
catcher.catch(TERMINAL_MEMORY_USED);
catcher.catch(TERMINAL_X64);
catcher.catch(TERMINAL_OPENCL_SUPPORT);
catcher.catch(TERMINAL_DISK_SPACE);
catcher.catch(TERMINAL_CPU_CORES);
catcher.catch(TERMINAL_MQID);
catcher.catch(TERMINAL_COMMUNITY_ACCOUNT);
catcher.catch(TERMINAL_COMMUNITY_CONNECTION);
catcher.catch(TERMINAL_NOTIFICATIONS_ENABLED);
catcher.catch(TERMINAL_SCREEN_DPI);
catcher.catch(TERMINAL_PING_LAST);
catcher.catch(TERMINAL_SCREEN_LEFT);
catcher.catch(TERMINAL_SCREEN_TOP);
catcher.catch(TERMINAL_SCREEN_WIDTH);
catcher.catch(TERMINAL_SCREEN_HEIGHT);
catcher.catch(TERMINAL_LEFT);
catcher.catch(TERMINAL_TOP);
catcher.catch(TERMINAL_RIGHT);
catcher.catch(TERMINAL_BOTTOM);
catcher.catch(TERMINAL_VPS);
catcher.catch(TERMINAL_KEYSTATE_TAB);
catcher.catch(TERMINAL_KEYSTATE_ENTER);
catcher.catch(TERMINAL_KEYSTATE_SHIFT);
catcher.catch(TERMINAL_KEYSTATE_CONTROL);
catcher.catch(TERMINAL_KEYSTATE_MENU);
catcher.catch(TERMINAL_KEYSTATE_CAPSLOCK);
catcher.catch(TERMINAL_KEYSTATE_ESCAPE);
catcher.catch(TERMINAL_KEYSTATE_PAGEUP);
catcher.catch(TERMINAL_KEYSTATE_PAGEDOWN);
catcher.catch(TERMINAL_KEYSTATE_END);
catcher.catch(TERMINAL_KEYSTATE_HOME);
catcher.catch(TERMINAL_KEYSTATE_LEFT);
catcher.catch(TERMINAL_KEYSTATE_UP);
catcher.catch(TERMINAL_KEYSTATE_RIGHT);
catcher.catch(TERMINAL_KEYSTATE_DOWN);
catcher.catch(TERMINAL_KEYSTATE_INSERT);
catcher.catch(TERMINAL_KEYSTATE_DELETE);
catcher.catch(TERMINAL_KEYSTATE_NUMLOCK);
catcher.catch(TERMINAL_KEYSTATE_SCRLOCK);
catcher.catch(TERMINAL_COMPANY);
catcher.catch(TERMINAL_NAME);
catcher.catch(TERMINAL_PATH);
catcher.catch(TERMINAL_DATA_PATH);
catcher.catch(TERMINAL_COMMONDATA_PATH);
catcher.catch(TERMINAL_LANGUAGE);
catcher.catch(TERMINAL_CPU_NAME);
catcher.catch(TERMINAL_OS_VERSION);
catcher.catch(PERIOD_CURRENT);
catcher.catch(PERIOD_M1);
catcher.catch(PERIOD_M2);
catcher.catch(PERIOD_M3);
catcher.catch(PERIOD_M4);
catcher.catch(PERIOD_M5);
catcher.catch(PERIOD_M6);
catcher.catch(PERIOD_M10);
catcher.catch(PERIOD_M12);
catcher.catch(PERIOD_M15);
catcher.catch(PERIOD_M20);
catcher.catch(PERIOD_M30);
catcher.catch(PERIOD_H1);
catcher.catch(PERIOD_H2);
catcher.catch(PERIOD_H3);
catcher.catch(PERIOD_H4);
catcher.catch(PERIOD_H6);
catcher.catch(PERIOD_H8);
catcher.catch(PERIOD_H12);
catcher.catch(PERIOD_D1);
catcher.catch(PERIOD_W1);
catcher.catch(PERIOD_MN1);
catcher.catch(TRADE_ACTION_DEAL);
catcher.catch(TRADE_ACTION_PENDING);
catcher.catch(TRADE_ACTION_SLTP);
catcher.catch(TRADE_ACTION_MODIFY);
catcher.catch(TRADE_ACTION_REMOVE);
catcher.catch(TRADE_ACTION_CLOSE_BY);
catcher.catch(TRADE_TRANSACTION_ORDER_ADD);
catcher.catch(TRADE_TRANSACTION_ORDER_UPDATE);
catcher.catch(TRADE_TRANSACTION_ORDER_DELETE);
catcher.catch(TRADE_TRANSACTION_HISTORY_ADD);
catcher.catch(TRADE_TRANSACTION_HISTORY_UPDATE);
catcher.catch(TRADE_TRANSACTION_HISTORY_DELETE);
catcher.catch(TRADE_TRANSACTION_DEAL_ADD);
catcher.catch(TRADE_TRANSACTION_DEAL_UPDATE);
catcher.catch(TRADE_TRANSACTION_DEAL_DELETE);
catcher.catch(TRADE_TRANSACTION_POSITION);
catcher.catch(TRADE_TRANSACTION_REQUEST);
catcher.catch(VECTOR_CONVOLVE_FULL);
catcher.catch(VECTOR_CONVOLVE_SAME);
catcher.catch(VECTOR_CONVOLVE_VALID);
catcher.catch(VECTOR_NORM_INF);
catcher.catch(VECTOR_NORM_MINUS_INF);
catcher.catch(VECTOR_NORM_P);



}

